program faces;
{ bertragung von Amiga/Colorix }
{ 06.12.97: Fertigstellen der Icons, des Backgroundes, der Gameloop   }
{ 13.12.97: Grimassen, Eier, Sternchen, Besen, Timer-Tuning Penti/W95 }
{ 14.12.97: Ende-Routine, Hiscore, Eingangsscreen ---> Vers.1.000     }
{           1 internes Level mit Steinchen                            }
{ 19.12.97: Vers.1.1: The Little Creature Feature hat zugeschlagen    }
{ 27.12.97: Vers.1.101: Animation am Ende des Spiels                  }
{ ------------------------------------------------------------------- }

{$M 8192,0,655360}

uses dos,crt,graph,intuit,hiscore;

procedure delay1(ms:word);
assembler;
asm
   mov ax,1000;
   mul ms;
   mov cx,dx;
   mov dx,ax;
   mov ah,$86
   int $15;
end;

const dx=24; dy=24; xmax=10; ymax=17; ox=180; oy=16; oyy=96; oxx=46;
      sonder=7;
      imafile='faces0.ima'; hscfile='faces.hsc'; levelfile='faces.l';
      titel='o    F  A  C  E  S   ( Amigas Colorix )   o   UJa Vers.1.200  o    TP6     o';
      pal:array[0..15,0..2] of word=
          ((  0,  0,  0),( 28,  4,  2),( 63, 19,  0),( 47, 24, 18),
           ( 57, 38, 31),( 62, 56, 29),( 29, 49, 25),(  8, 35, 26),
           (  0, 11, 22),( 12, 32, 49),( 26, 44, 58),( 48, 53, 57),
           ( 17, 16, 21),( 29, 33, 35),( 50, 53, 49),( 63, 63, 63));

type feld=array[-1..xmax+2,-2..ymax+2] of integer;
     face=record
             x,y,xx,yy,phase,size:integer;
             horiz               :boolean;
             typ                 :array[0..2,0..2] of integer;
          end;
     liste=array[0..xmax*ymax,0..1] of integer;
     list2=array[0..7,0..1] of integer;

var ima                                      :array[0..47] of image;
    backima                                  :array[1..4] of image;
    stein,nextstein                          :face;
    i,j,k,level,count,fac,count1             :integer;
    ok,ende,haengtfest,sense,anzeige,grimasse:boolean;
    ch                                       :char;
    f                                        :feld;
    l                                        :liste;
    l2                                       :list2;
    pkt,pkto                                 :longint;
    temp,t1                                  :string;
    hsc                                      :HighScore;


{ ----------------------------------------------------------------------- }
{$i faces.inc }  { Suche nach gleichfarbigen Nachbarn und Listenaufbau    }
{$i faces1.inc } { Images laden, Darstellung Faces, Elemente und Messages }
{$i faces2.inc } { Moves, Transformationen, Check auf Haenger             }
{$i faces3.inc } { Goodies und deren Auswertung                           }
{ ----------------------------------------------------------------------- }

procedure ladelevel(var level:integer);
var i,j,k   :integer;
    infile,t:string;
    disk    :text;
begin
   str(level:2,infile);
   if infile[1]=' ' then infile[1]:='0';
   infile:=levelfile+infile;
{$i-}
   assign(disk,infile);
   reset(disk);
   if ioresult=0 then begin
   for j:=1 to ymax do begin
      readln(disk,t);
      for i:=1 to length(t) do case t[i] of
      '.'     : f[i,j]:=0;
      '0'..'7': f[i,j]:=ord(t[i])-48;
      '#'     : f[i,j]:=8;
      'B'     : f[i,j]:=29;
      'C'     : f[i,j]:=12;
      'H'     : f[i,j]:=31;
      'S'     : f[i,j]:=30;
      'h'     : f[i,j]:=28;
      else f[i,j]:=0;
      end;
   end;
   close(disk);
   end else level:=-1;
   for i:=1 to xmax do for j:=1 to ymax do zeichne(i,j,f[i,j]);
end;


procedure initfeld;
var i,j:integer;
begin
for j:=-2 to ymax+2 do for i:=-1 to xmax+2 do f[i,j]:=8;
for j:=0 to ymax do for i:=1 to xmax do f[i,j]:=0;
rectfill(ox+dx,oy,pred(ox+succ(xmax)*dx),pred(oy+succ(ymax)*dy),8);
end;


procedure initstein(var stein,nextstein:face; var haenger:boolean; anzeige:boolean);

   procedure generate(var stein:face);
   var i,j,k:integer;
   begin
      with stein do begin
         size:=random(3);
         x:=succ(random(10-size));
         y:=0;
         xx:=0;
         yy:=0;
         phase:=0;
         horiz:=true;
         for i:=0 to 2 do for j:=0 to 2 do typ[i,j]:=0;
         for i:=0 to size do typ[i,0]:=succ(random(6));
      end;
   end;

begin
   randomize;
   if stein.x=-1 then generate(nextstein); { neues Spiel }
   stein:=nextstein;
   generate(nextstein);
   if anzeige then with nextstein do begin
      rectfill(oxx,oyy-2,pred(oxx+3*dx),pred(oyy+dy),8);
      for i:=0 to size do case size of
      0: putimage(oxx+i*dx+dx,oyy,ima[typ[i,0]].p_data^,normalput);
      1: putimage(oxx+i*dx+(dx div 2),oyy,ima[typ[i,0]].p_data^,normalput);
      2: putimage(oxx+i*dx,oyy,ima[typ[i,0]].p_data^,normalput);
      end;
   end;
   zeichnestein(stein);
   delay1(100);
   haenger:=false;
   with stein do
   if horiz then for i:=0 to size do if f[x+i,y]<>0 then haenger:=true
            else for i:=0 to size do if f[x,y+i]<>0 then haenger:=true;
end;

procedure redraw(flag:boolean);
var i,j:integer;
begin
background;
if flag then for i:=1 to xmax do saeule(i);
if anzeige then with nextstein do begin
   rectfill(oxx,oyy-2,pred(oxx+3*dx),pred(oyy+dy),8);
   for i:=0 to size do case size of
   0: putimage(oxx+i*dx+dx,oyy,ima[typ[i,0]].p_data^,normalput);
   1: putimage(oxx+i*dx+(dx div 2),oyy,ima[typ[i,0]].p_data^,normalput);
   2: putimage(oxx+i*dx,oyy,ima[typ[i,0]].p_data^,normalput);
   end;
end;
end;

procedure screen0;
begin
   holeimas;
   background;
end;

procedure screen1;
begin
   pkt:=0;
   level:=0;
   ende:=false;
   count:=0;
   initfeld;
   initstein(stein,nextstein,sense,true);
   count1:=55;
   str((count1-5):3,temp);
   temp:='Speed'+temp;
   str(level:3,t1);
   temp:=temp+'    -     Level'+t1;
   messi(temp);
   redraw(true);
end;


procedure laufschrift(x,size:integer);    { ima[32] auf 0,512 }
var x1,x2,y1,y2:integer;
begin
with ima[32] do begin
   if count<size then begin
      x1:=0;
      x2:=count;
      getimage(x1,512,x2,519,p_data^);
      putimage(639-count,468,p_data^,normalput);
   end else if count<640 then begin
      getimage(0,512,pred(width),pred(512+height),p_data^);
      putimage(639-count,468,ima[32].p_data^,normalput);
   end else begin
      x1:=count-640;
      x2:=pred(width);
      if x1<x2 then begin
      getimage(x1,512,x2,519,p_data^);
      putimage(0,468,p_data^,normalput);
      end;
   end;
end;
end;


procedure help;
const x=72; y=36; yy=12;
var t:string;
    i,j,k:integer;
    anz:word;
begin
while keypressed do ch:=readkey;
background;
rectfill(64,40,575,387,0);
rectfill(65,41,574,386,3);
rectfill(66,42,573,385,15);
rectfill(67,43,572,384,4);
for i:=1 to 29 do begin case i of
 1: temp:='UJAs Faces (Remake der Amiga-Version von Colorix)';
 2: temp:='--------------------------------------------------------------';
 3: temp:='Freche Bengels und Gren huschen von oben nach unten ber den ';
 4: temp:='Screen. Du wirds sie los, wenn Du mindestens 3 von einer Sorte';
 5: temp:='zusammenbringst, sie besprechen sich wahrscheinlich, um jemand';
 6: temp:='andern zu nerven oder sich weiteren Schabernack auszudenken.  ';
 7: temp:='Pa auf, da sie nicht berhandnehmen.                        ';
 8: temp:='--------------------------------------------------------------';
 9: temp:='[Cursor links]  dirigiert sie nach links,                     ';
10: temp:='[Cursor rechts] dirigiert sie nach rechts,                    ';
11: temp:='[Cursor oben]   damit drehen sie sich,                        ';
12: temp:='[Cursor unten]  sie springen nach unten und suchen sich ein   ';
13: temp:='                Ruhepltzchen,                                ';
14: temp:='[F]             die beiden ueren Kids tauschen die Pltze,  ';
15: temp:='[Leertaste]     sie spielen einmal "Ringelreihen",            ';
16: temp:='[P]             "Pinkelpause"                                 ';
17: temp:='[esc]           kannst Du drcken, wenn Du die Nase voll hast.';
18: temp:='--------------------------------------------------------------';
19: temp:='Spielzeug der Kinder:                                         ';
20: temp:='Knallfrsche, ein alter Besen, Eier, gro genug um sich dahin-';
21: temp:='ter zu verstecken, und Voodo-(Schrumpf?-)Kpfe, die sie beim  ';
22: temp:='Verschwinden wieder einkassieren.                             ';
23: temp:='Coladosen werden wild in die Landschaft geschmissen, dirigiert';
24: temp:='man ein Kid dahin und findet sich eine Gruppe von 3 oder mehr ';
25: temp:='Kids einer Sorte, so rumt es die Coladose weg. Die anderen   ';
26: temp:='Kids in der Nhe der Dose haben sich natrlich verdrckt.     ';
27: temp:='--------------------------------------------------------------';
28: temp:='           zum Spiel: beliebige Taste drcken                 ';
29: temp:='*                Vielen Dank an Tom Mai fr die Delay-Routine ';
end;
k:=y+i*yy;
if i>8 then k:=k-4;
if i>18 then k:=k-4;
if i>27 then k:=k-4;
setcolor(14); outtextxy(succ(x),k,temp);
if (i=1) or (i=28) then setcolor(8) else setcolor(0);
if i=29 then setcolor(1);
outtextxy(x,k,temp);
end;

t:='*** HDS proudly presents: Faces, annother UJa-Game ***';
randomize;
for i:=1 to xmax do if random(10)<5 then zeichne(i,0,succ(random(6)));
count:=0;

rectfill(0,468,639,477,14);
with ima[32] do begin
   width:=320;
   anz:=imagesize(1,1,width,height);
   p_nextimage:=nil;
   getmem(p_data,anz);
   getimage(0,468,pred(width),pred(468+height),p_data^);
   putimage(0,512,ima[32].p_data^,normalput);
   putimage(320,512,ima[32].p_data^,normalput);
end;

with ima[32] do begin
   width:=length(t)*8+4;
   anz:=imagesize(1,1,width,height);
   p_nextimage:=nil;
   setcolor(15); outtextxy(2,468,t);
   setcolor(0); outtextxy(1,468,t);
   getimage(0,468,pred(width),pred(468+height),p_data^);
   putimage(0,512,p_data^,normalput);
end;

rectfill(0,468,639,477,14);
while not keypressed do begin
   laufschrift(count,ima[32].width);
   inc(count);
   delay1(4*fac);
   if count=640 then zeichne(xmax,ymax,28);
   if count=800 then zeichne(xmax,ymax,0);
   if count>640+ima[32].width then count:=0;
end;
ende:=readkey=#27;
if not ende then redraw(false);
end;

{ ------------------------------------------------------------------- }
procedure keys(var haenger:boolean; var l:liste);
var i,j,k  :integer;
    ch0,ch1:char;
begin
   haenger:=false;
   delay1(fac);

  while keypressed do begin
      ch0:=readkey;
      case ch0 of
      #32: shift(stein);
      #27: begin
              ende:=true;
              while keypressed do ch1:=readkey;
           end;
      #59: help;
      #72: drehe(stein);
      #75: rechtslinks(stein,false);
      #77: rechtslinks(stein,true);
      #80: haenger:=true;
      '+'    : begin
                  inc(level);
                  ladelevel(level);
                  for i:=1 to xmax do saeule(i);
                  str(level:3,temp);
                  temp:='Level'+temp;
                  str((count1-4):3,t1);
                  temp:=temp+'   - Speed: '+t1;
                  messi(temp);
               end;
      '-'    : begin
                  dec(level);
                  ladelevel(level);
                  for i:=1 to xmax do saeule(i);
                  str(level:3,temp);
                  temp:='Level'+temp;
                  str((count1-4):3,t1);
                  temp:=temp+'   - Speed: '+t1;
                  messi(temp);
               end;
      'F','f': flip(stein);
      'H','h': help;
      'P','p': begin
                  while keypressed do ch:=readkey;
                  ch:=readkey;
               end;
      end;
      if haenger then begin
         while keypressed do ch1:=readkey;
      end;
      ch0:='#';
   end;
end;

{ ------------------------------------------------------------------- }

procedure gameover;
var x1,x2,x,y,i,j,xx,yy:integer;  faceda:boolean;
begin
   while keypressed do ch:=readkey;
   x1:=dx+ox; x2:=pred(xmax)*dx+ox;
   for j:=0 to ymax do begin
      for i:=x1 to x2 do begin
         y:=j*dy+oy;
         putimage(i,y,ima[11].p_data^,normalput);
         setcolor(8); line(i,y,i,y+pred(dy));
         xx:=0;
         yy:=0;
         if keypressed then begin
            ch:=readkey;
            if ch=#27 then begin ende:=true; exit; end;
            if ch=#32 then exit;
         end 
      end;
      delay1(fac);
      rectfill(9*dx+ox,j*dy+oy,pred(succ(xmax)*dx+ox),pred(succ(j)*dy+oy),8);
   end;
   updathighscore(pkt,hscfile,hsc,dx+ox-2,oy+11*dy+16,12,3,6,0,8);

   j:=oy; xx:=random(xmax*dx-ima[27].width)+ox+dx;
   while not keypressed do begin
      putimage(xx,j,ima[27].p_data^,normalput);
      delay1(fac);
      inc(j);
      if j>10*dy+8+oy then begin
         rectfill(ox+dx,10*dy+oy+8,pred(ox+succ(xmax)*dx),pred(oy+8+10*dy+ima[27].height),8);
         if faceda then for i:=0 to 5 do zeichne(i-8,0,0);
         faceda:=random(10)<2;
         if faceda then for i:=0 to 5 do begin
            k:=random(21);
            if k<7 then zeichne(i-8,0,succ(k));
         end;
         delay1(250*fac);
         j:=oy;
         xx:=xx+succ(random(dx));
         if xx>=succ(xmax)*dx+ox-ima[27].width then xx:=ox+dx;
      end;
   end;
   if ch=#27 then begin ende:=true; exit; end;
end;

{ --------------------------------------------------------------------- }

procedure durchgespielt;
var i:integer; infile:string; fh:file;  anz:word; t:string;
begin
   for i:=1 to 4 do begin
      infile:=imafile;
      infile[6]:=chr(52+i);
      assign(fh,infile);
      reset(fh,1);
      BlockRead(fh,ima[38+i],sizeof(image),anz);
      with ima[38+i] do begin
         anz:=Imagesize(1,1,width,height);
         GetMem(p_data,anz);
         BlockRead(fh,p_data^,anz,anz);
         putimage(pred(i)*width,16,ima[38+i].p_data^,normalput);
         FreeMem(p_data,anz);
      end;
      close(fh);
   end;
   while keypressed do ch:=readkey;

t:='*** HDS proudly presents: Faces, annother UJa-Game ***';
rectfill(0,468,639,477,14);

while not keypressed do begin
   laufschrift(count,ima[32].width);
   if count mod 16=0 then putimage(192,256,ima[43].p_data^,normalput);
   if count mod 16=8 then putimage(192,256,ima[44].p_data^,normalput);
   inc(count);
   delay1(4*fac);
   if count>640+ima[32].width then count:=0;
end;
   ende:=readkey=#27;
end;

{ ================================================================== }

begin
fac:=5; { Toemmskens Routine }

initscreen(ok);
stein.x:=-1;
if ok then begin
   screen0;
   loadhighscore(hscfile,hsc);
   help;
   if not ende then repeat
   screen1;
   pkt:=0;
   repeat  { Gameloop }
      keys(haengtfest,l);
      inc(count);
      if not haengtfest then if count>count1 then begin
         delay1(5*fac);
         drop(stein,haengtfest);
         count:=0;
      end;

      if haengtfest then begin
         pkt:=pkt+succ(stein.size);
         dropdead(stein,l2);
         schule(l2,sense);
         if not sense then begin
            bett(l2,pkt);
            repeat
               pkto:=pkt;
               dropzone(pkt);
               if pkt>pkto then if l2[0,0]>0 then begin
                  colaflasche(l2,pkt);
                  l2[0,0]:=0;
               end;
            until pkt=pkto;
            updatpunkte(pkt);

            i:=random(50);
            case i of
              0..1: if count1<15 then besen;
              2..3: if level mod 3 >0 then colawerfen(sense);
              4..5: if count1<20 then begin
                       sternchen;
                       dropzone(pkt);
                    end;
              6..8: if level mod 3 >1 then ghostwerfen(sense);
             9..10: if level mod 3 >2 then eierwerfen(sense);
            end;
            initstein(stein,nextstein,haengtfest,true);
            grimasse:=random(100)<5;
         end;
         sense:=sense or haengtfest;
         dec(count1);
         if count1<5 then begin
            count1:=55;
            inc(level);
            ladelevel(level);
            if level>-1 then for i:=1 to xmax do saeule(i);
         end;
         str(level:3,temp);
         temp:='Level'+temp;
         str((count1-4):3,t1);
         temp:=temp+'   - Speed: '+t1;
         messi(temp);
      end;
      if sense then begin
         messi('G A M E   O V E R');
         gameover;
         ch:=readkey;
         ende:=ch=#27;
      end;
   until sense or ende or (level<0);
   if level<0 then durchgespielt;
   if not ende then help;
   until ende;
end;
textmode(3);
end.
