program faceslev;
{ Leveleditor fr Faces }

{$M 8192,0,655360}

uses dos,crt,graph,intuit,drivers;

const dx=24; dy=24; xmax=10; ymax=17; ox=180; oy=16; oyy=96; oxx=46;
      imafile='faces0.ima'; hscfile='faces.hsc'; levelfile='faces.l';
      titel='o    Faces-Leveleditor:                   o   UJa Vers.1.0   o     TP6     o';
      pal:array[0..15,0..2] of word=
          ((  0,  0,  0),( 28,  4,  2),( 63, 19,  0),( 47, 24, 18),
           ( 57, 38, 31),( 62, 56, 29),( 29, 49, 25),(  8, 35, 26),
           (  0, 11, 22),( 12, 32, 49),( 26, 44, 58),( 48, 53, 57),
           ( 17, 16, 21),( 29, 33, 35),( 50, 53, 49),( 63, 63, 63));

type feld=array[-1..xmax+2,-2..ymax+2] of integer;

var ima                    :array[0..11] of image;
    igad                   :array[1..18] of Gadget;
    itext1,itext2          :array[1..5]  of IntuiText;
    ibord1,ibord2,ibord3   :Border;
    xy1,xy2,xy3            :Koords;
    stringinfo             :strinfo;
    level,i,j,select,mx,my,g    :integer;
    ok,ende                     :boolean;
    ch                          :char;
    f                           :feld;

{ ------------------------------------------------------------------ }

procedure holeimages;
var fh    :file;
    i     :integer;
    anz   :word;
    infile:string;
begin
   for i:=1 to 15 do setpalette(i,0);
   for i:=1 to 4 do begin
      infile:=imafile;
      infile[6]:=chr(48+i);
      assign(fh,infile);
      reset(fh,1);
      BlockRead(fh,ima[0],sizeof(image),anz);
      with ima[0] do begin
         anz:=Imagesize(1,1,width,height);
         GetMem(p_data,anz);
         BlockRead(fh,p_data^,anz,anz);
         putimage(pred(i)*width,16,ima[0].p_data^,normalput);
         FreeMem(p_data,anz);
      end;
      close(fh);
   end;

   { Icons }
   with ima[0] do begin                        { leer }
      setcolor(0);
      line(pred(ox+2*dx),oy,pred(ox+2*dx),pred(oy+dy));
      line(ox+dx,pred(oy+dy),pred(ox+2*dx),pred(oy+dy));
      x:=0;
      y:=0;
      width:=dx;
      height:=dy;
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
      GetImage(ox+dx,oy,pred(2*dx+ox),pred(dy+oy),p_data^);
      p_nextimage:=nil;
   end;
   for i:=1 to 7 do with ima[i] do begin       { Faces }
      x:=0;
      y:=0;
      width:=dx;
      height:=dy;
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
      GetImage(ox+i*dx,oy+dy,pred(succ(i)*dx+ox),pred(2*dy+oy),p_data^);
      p_nextimage:=nil;
   end;
   with ima[8] do begin     { Stein }
      x:=0;
      y:=0;
      width:=dx;
      height:=dy;
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
      GetImage(ox+2*dx,oy,pred(3*dx+ox),pred(dy+oy),p_data^);
      p_nextimage:=nil;
   end;
   with ima[9] do begin                       { Cola }
      x:=0;
      y:=0;
      width:=dx;
      height:=dy;
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
      GetImage(ox+7*dx,oy,pred(8*dx+ox),pred(dy+oy),p_data^);
      p_nextimage:=nil;
   end;
   for i:=1 to 2 do with ima[i+9] do begin     { 10,11: Bett, Schule }
      x:=0;
      y:=0;
      width:=dx;
      height:=dy;
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
      GetImage(ox+8*dx,oy+i*dy,pred(9*dx+ox),pred(succ(i)*dy+oy),p_data^);
      p_nextimage:=nil;
   end;
   for i:=0 to 15 do setrgbpalette(i,pal[i,0],pal[i,1],pal[i,2]);
end;

procedure initgadgets;
var i,j,k:integer;
begin
itext1[1].itext:='Level: ';
itext1[2].itext:=' Laden';
itext1[3].itext:='Sichern';
itext1[4].itext:='  Neu';
itext1[5].itext:=' Ende';
for i:=1 to 5 do with itext1[i] do begin
   if i=1 then x:=-47 else x:=5;
   y:=4;
   bpen:=13;
   fpen:=15;
   p_nexttext:=addr(itext2[i]);
end;
itext2:=itext1;
for i:=1 to 5 do with itext2[i] do begin
   x:=pred(itext1[i].x);
   fpen:=0;
   bpen:=14;
   drmode:=jam1;
   p_nexttext:=nil;
end;
xy1[0]:=0; xy1[1]:=14; xy1[2]:=0;  xy1[3]:=0;  xy1[4]:=63; xy1[5]:=0;
xy2[0]:=0; xy2[1]:=15; xy2[2]:=63; xy2[3]:=15; xy2[4]:=63; xy2[5]:=1;
xy3[0]:=0; xy3[1]:=0;  xy3[2]:=pred(dx); xy3[3]:=0; xy3[4]:=pred(dx);
xy3[5]:=pred(dy); xy3[6]:=0; xy3[7]:=pred(dy); xy3[8]:=0; xy3[9]:=0;

with ibord1 do begin
   x:=0; y:=0; fpen:=15; bpen:=14; ecken:=3; p_ecken:=addr(xy1);
   drmode:=jam1; p_nextborder:=addr(ibord2);
end;
with ibord2 do begin
   x:=0; y:=0; fpen:=0; bpen:=14; ecken:=3; p_ecken:=addr(xy2);
   drmode:=jam1; p_nextborder:=nil;
end;
with ibord3 do begin
   x:=0; y:=0; fpen:=15; bpen:=14; ecken:=5; p_ecken:=addr(xy3);
   drmode:=jam1; p_nextborder:=nil;
end;

with stringinfo do begin
   x:=4; y:=4; maxlen:=3; fpen:=0; bpen:=15; buff:='99'; ubuff:='99';
end;
for i:=1 to 5 do with igad[i] do begin
   id:=i;
   if i=1 then x:=64 else x:=64*i+256;
   y:=465; width:=64; height:=16; bpen:=-1; hibpen:=-1;
   p_loborder:=addr(ibord1); p_hiborder:=p_loborder;
   p_loimage:=nil; p_hiimage:=p_loimage;
   p_lointuitext:=addr(itext1[i]); p_hiintuitext:=p_lointuitext;
   if i=1 then gadgettyp:=strgadget else gadgettyp:=boolgadget;
   onoff:=false; active:=true;
   if i=1 then p_specialInfo:=addr(stringinfo) else p_specialinfo:=nil;
   p_flinfo:=nil;
   p_nextgadget:=addr(igad[succ(i)]);
end;
with igad[6] do begin
   id:=6; x:=ox+dx; y:=oy+dy; width:=xmax*dx; height:=ymax*dy;
   bpen:=-1; hibpen:=-1;
   p_loborder:=nil; p_hiborder:=p_loborder;
   p_loimage:=nil; p_hiimage:=p_loimage;
   p_lointuitext:=nil; p_hiintuitext:=p_lointuitext;
   gadgettyp:=boolgadget; onoff:=false; active:=true;
   p_specialinfo:=nil; p_flinfo:=nil;
   p_nextgadget:=addr(igad[7]);
end;

for i:=7 to 12 do with igad[i] do begin
   id:=i; x:=480+(i-7)*dx; y:=240; width:=dx; height:=dy;
   bpen:=-1; hibpen:=-1;
   p_loborder:=nil; p_hiborder:=addr(ibord3);
   p_loimage:=addr(ima[i-7]); p_hiimage:=p_loimage;
   p_lointuitext:=nil; p_hiintuitext:=p_lointuitext;
   gadgettyp:=boolgadget; onoff:=false; active:=true;
   p_specialinfo:=nil; p_flinfo:=nil;
   p_nextgadget:=addr(igad[succ(i)]);
end;
for i:=13 to 18 do with igad[i] do begin
   id:=i; x:=480+(i-13)*dx; y:=240+dy; width:=dx; height:=dy;
   bpen:=-1; hibpen:=-1;
   p_loborder:=nil; p_hiborder:=addr(ibord3);
   p_loimage:=addr(ima[i-7]); p_hiimage:=p_loimage;
   p_lointuitext:=nil; p_hiintuitext:=p_lointuitext;
   gadgettyp:=boolgadget; onoff:=false; active:=true;
   p_specialinfo:=nil; p_flinfo:=nil;
   if i<18 then p_nextgadget:=addr(igad[succ(i)]) else p_nextgadget:=nil;
end;
end;


procedure background;
var x,y:integer;
begin
   rectfill(ox+dx,oy,pred(succ(xmax*dx+ox)),pred(succ(ymax*dy+oy)),8);
   rectfill(0,1,639,14,13);
   rectfill(oxx,oyy-2,oxx+3*dx,oyy+dy,8);
   setcolor(15); line(0,0,639,0);     outtextxy(17,4,titel);
   setcolor(0); line(0,15,639,15);    outtextxy(16,4,titel);
   rectfill(0,465,639,479,14);
   setcolor(0); line(0,464,639,464);
   for i:=1 to 15 do setpalette(i,i);
   RefreshGadgets(addr(igad[1]));
end;

{ ------------------------------------------------------------------------ }

procedure zeichne(x,y,typ:integer);
begin
   putimage(x*dx+ox,y*dy+oy,ima[typ].p_data^,normalput);
end;

procedure messi(t:string);
begin
rectfill(144,468,360,477,14);
setcolor(15); outtextxy(145,468,t);
setcolor(1);  outtextxy(144,468,t);
end;


procedure ladelevel(var level:integer);
var i,j,k   :integer;
    infile,t:string;
    disk    :text;
begin
   str(level:2,infile);
   if infile[1]=' ' then infile[1]:='0';
   infile:=levelfile+infile;
   messi(infile+' wird geladen');

{$i-}
   assign(disk,infile);
   reset(disk);
   if ioresult=0 then begin
   for j:=1 to ymax do begin
      readln(disk,t);
      for i:=1 to length(t) do case t[i] of
      '.'     : f[i,j]:=0;
      '0'..'7': f[i,j]:=ord(t[i])-48;
      '#'     : f[i,j]:=8;
      'B'     : f[i,j]:=10;
      'C'     : f[i,j]:=9;
      'S'     : f[i,j]:=11;
      else f[i,j]:=0;
      end;
   end;
   close(disk);
   messi(infile+' ist geladen');
   end else messi(infile+' nicht gefunden');
   for i:=1 to xmax do for j:=1 to ymax do zeichne(i,j,f[i,j]);
end;

procedure savelevel(var level:integer);
var i,j,k   :integer;
    infile,t:string;
    disk    :text;
begin
   str(level:2,infile);
   if infile[1]=' ' then infile[1]:='0';
   infile:=levelfile+infile;
   messi(infile+' wird gespeichert');

{$i-}
   assign(disk,infile);
   rewrite(disk);
   for j:=1 to ymax do begin
      t:='';
      for i:=1 to xmax do case f[i,j] of
      0   : t:=t+'.';
      1..7: t:=t+chr(48+f[i,j]);
      8   : t:=t+'#';
      9   : t:=t+'C';
      10  : t:=t+'B';
      11  : t:=t+'S';
      end;
      writeln(disk,t);
   end;
   close(disk);
   messi(infile+' ist gespeichert');
end;


procedure initfeld;
var i,j:integer;
begin
for i:=1 to xmax do for j:=1 to ymax do begin
   f[i,j]:=0;
   zeichne(i,j,f[i,j]);
end;
end;


{ ======================================================================== }

begin
initscreen(ok);
if ok then begin
   holeimages;
   initgadgets;
   background;
   ende:=false;
   initfeld;
   select:=0;
   while not ende do begin
      showmouse;
      delay(50);
      if keypressed then begin
         ch:=readkey;
         case ch of
         'L','l': g:=2;
         'S','s': g:=3;
         'N','n': g:=4;
         #27,'E','Q','e','q': g:=5;
         end;
      end else getgadget(addr(igad[1]),g,mx,my);
      hidemouse;
      case g of
      1: begin
            getstring(igad[g]);
            with stringinfo do begin
               val(buff,i,j);
               if j=0 then level:=i;
               str(level:2,buff);
               if buff[1]=' ' then buff[1]:='0';
            end;
            Drawgadget(addr(igad[g]));
         end;
      2: ladelevel(level);
      3: savelevel(level);
      4: initfeld;
      5: ende:=true;
      6: begin
            i:=(mx-ox) div dx;
            j:=(my-oy) div dy;
            f[i,j]:=select;
            zeichne(i,j,f[i,j]);
         end;
      7..18: begin
                select:=g-7;
                putimage(oxx+dx,oyy,ima[select].p_data^,normalput);
             end;
      end;
   end;
end;
textmode(3);
end.
